import { csv, select } from 'd3';
import { scatterPlot } from './scatterPlot';

const csvUrl = [
  'https://gist.githubusercontent.com/Mahesh-Polisetty/73973ad2648ad0efbb108663ae84f7e4/raw/c17e057e6e1ecbc52d8e0b7d1afdb985331bd173/A6q2.csv', // File name
].join('');
const parseRow = (d) => {
  d.citric_acid = +d.citric_acid;
  d.sulphates = +d.sulphates;
  d.residual_sugar = +d.residual_sugar;
  d.alcohol = +d.alcohol;
  return d;
};

const width = window.innerWidth;
const height = window.innerHeight;
const svg = select('body')
  .append('svg')
  .attr('width', width)
  .attr('height', height);

const main = async () => {
  const plot = scatterPlot()
    .width(width)
    .height(height)
    .data(await csv(csvUrl, parseRow))
    .xValue((d) => d.residual_sugar)
    .yValue((d) => d.citric_acid)
    .margin({
      top: 20,
      right: 20,
      bottom: 40,
      left: 50,
    })
    .radius(5);

  svg.call(plot);

  const columns = [
    'citric_acid',
    'sulphates',
    'residual_sugar',
    'alcohol',
  ];
  let i = 0;
  setInterval(() => {
    plot.xValue((d) => d[columns[i % columns.length]]);
    svg.call(plot);
    i++;
  }, 2000);
};
main();
